﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using System.ComponentModel;

namespace AxisDataTemplateAndFormat
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ViewModel vm = new ViewModel();
            combo.ItemsSource = new List<string>
            {
                "Millions",
                "Billions"
            };
            DataContext = vm;
        }

    }

    public class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            List<Data> data = new List<Data>();
            Random r = new Random();

            for (int i = 0; i < 10; i++)
            {
                data.Add(new Data { Label = "Item " + i, Value = r.Next(1500000000) });
            }

            DataSource = data;

            UnitType = "Billions";
            DecimalPrecision = 2;

        }

        private List<Data> data;

        public List<Data> DataSource
        {
            get { return data; }
            set { data = value; PropChanged("DataSource"); }
        }


        private int dec;

        public int DecimalPrecision
        {
            get { return dec; }
            set { dec = value; PropChanged("DecimalPrecision"); }
        }


        private string utype;

        public string UnitType
        {
            get { return utype; }
            set { utype = value; PropChanged("UnitType"); }
        }




        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class Data
    {
        public string Label { get; set; }
        public int Value { get; set; }
    }



    public class LabelFormatConerter : IMultiValueConverter
    {
        //public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        //{
        //    AxisItemDataContext context = value as AxisItemDataContext;

        //    double val = (double)context.Item;

        //    return (val / 1000000000) + " b";
        //}

        //public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        //{
        //    throw new NotImplementedException();
        //}

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            double value = (double)values[0];
            int prec = (int)values[2];
            string type = values[1].ToString();

            if (type.Equals("Millions"))
            {
                return (value / 1000000).ToString("N" + prec) + " M";
            }
            else
            {
                return (value / 1000000000).ToString("N" + prec) + " b";
            }
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
